package question11

import (
	"math/rand"
	"os"
	"strconv"
	"testing"
	"time"
)

var SIZE = 16

func TestMain(m *testing.M) {
	if len(os.Args) > 1 {
		if n, err := strconv.Atoi(os.Args[1]); err != nil {
			if len(os.Args) > 2 {
				if n, err := strconv.Atoi(os.Args[2]); err != nil {
					SIZE = 16
				} else {
					SIZE = n
				}
			} else {
				SIZE = 16
			}
		} else {
			SIZE = n
		}
	}
	os.Exit(m.Run())
}

func is_sorted(tab []int) bool {
	for i := 0; i < len(tab)-1; i++ {
		if tab[i] > tab[i+1] {
			return false
		}
	}
	return true
}

func TestSorted(t *testing.T) {
	tab := make([]int, SIZE)
	for i := 0; i < len(tab); i++ {
		tab[i] = i
	}
	tab = Sort(tab)
	t.Log("After sort: ", tab)
	if !is_sorted(tab) {
		t.Fatal("Failed to sort already sorted slice")
	}
}

func TestRevSorted(t *testing.T) {
	tab := make([]int, SIZE)
	for i := 0; i < len(tab); i++ {
		tab[i] = len(tab) - i - 1
	}
	tab = Sort(tab)
	t.Log("After sort: ", tab)
	if !is_sorted(tab) {
		t.Fatal("Failed to sort reverse sorted slice")
	}
}

func TestRandom(t *testing.T) {
	rand.Seed(time.Now().Unix())
	tab := make([]int, SIZE)
	for i := 0; i < len(tab); i++ {
		tab[i] = rand.Intn(65536)
	}
	tab = Sort(tab)
	t.Log("After sort: ", tab)
	if !is_sorted(tab) {
		t.Fatal("Failed to sort random slice")
	}
}
