package question16

import (
	"flag"
	"os"
	"testing"
)

var fname string = "graph.nde"
var dotfname string = ""

func TestMain(m *testing.M) {
	flag.StringVar(&fname, "graph", "graph.nde", "set graph file name")
	flag.StringVar(&dotfname, "dot", "", "set dot file name")
	flag.Parse()
	os.Exit(m.Run())
}

func TestGraph(t *testing.T) {
	g := ReadGraph(fname)
	st := NewSpanTree()
	g.DFSBuildSpanningTree(0, st)
	st.LogTree(t)
	if dotfname != "" {
		st.BuildDotFile(dotfname)
	}
}
