package question17

import (
	"fmt"
	"os"
)

func (g *Graph) isLinked(x, y int) bool {
	for _, s := range g.Vertices[x].Succ {
		if s == y {
			return true
		}
	}
	return false
}

func (g *Graph) AddEdge(x, y int) {
	if x < 0 || x >= g.Order || y < 0 || y >= g.Order {
		panic("Vertices not in graph")
	}
	if !g.isLinked(x, y) {
		g.Vertices[x].Succ = append(g.Vertices[x].Succ, y)
		g.Vertices[y].Pred = append(g.Vertices[y].Pred, x)
	}
}

func NewGraph(order int) *Graph {
	return &Graph{order, make([]Vertex, order)}
}

func ReadGraph(fname string) (g *Graph) {
	file, err := os.Open(fname)
	if err != nil {
		panic(err)
	}
	defer file.Close()
	order := 0
	c, err := fmt.Fscanln(file, &order)
	if c < 1 || err != nil {
		panic(err)
	}
	g = NewGraph(order)
	for {
		var x, y int
		if i, err := fmt.Fscanln(file, &x, &y); err != nil || i == 0 {
			break
		} else {
			g.AddEdge(x, y)
		}
	}
	return g
}
