/* EPITA - IP - S3/4 */
/* question08 */

#define QNUM 8
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question08.h"


static
void print_list(struct list *list, const char *prefix) {
  int line, base;
  base = line = printf("%s =", prefix);
  if (list->next == NULL) {
    printf(" EMPTY\n");
    return;
  }
  for (struct list *cur = list; cur->next; cur = cur->next) {
    if (line > 72) {
      printf("\n%*s", base, "");
      line = base;
    }
    line += printf(" -> %3d", cur->next->val);
  }
  printf("\n");
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  struct list *store;
  struct list *list;
  store = calloc(len + 2, sizeof (struct list));
 
  list = store;
  print_list(list, "list");

  for (size_t idx = 1; idx <= len; idx++) {
    struct list *elm = store + idx;
    elm->val = idx;
    printf("  insert %d in list\n", elm->val);
    list_insert(list, elm);
  }

  print_list(list, "list");
  free(store);
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  struct list *store;
  struct list *list;
  store = calloc(len + 2, sizeof (struct list));
 
  list = store;
  print_list(list, "list");

  for (size_t idx = 1; idx <= len; idx++) {
    struct list *elm = store + idx;
    elm->val = random() % 1000;
    printf("  insert %d in list\n", elm->val);
    list_insert(list, elm);
  }

  print_list(list, "list");
  free(store);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
