/* EPITA - IP - S3/4 */
/* question09 */

#define QNUM 9
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stddef.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question09.h"

# define containerof(TYPE_, FIELD_, PTR_)	  \
  (TYPE_*)((char*)PTR_ - offsetof(TYPE_, FIELD_))


struct data {
  size_t      val;
  struct list lst_;
};

static
struct list* build_randlist(size_t len, struct data store[]) {
  struct list *list = calloc(1, sizeof (struct list));
  for (struct data *cur = store; len; len--) {
    cur->lst_.next = list->next;
    list->next = &cur->lst_;
    cur->val = random() % 1000;
    cur += 1;
  }
  return list;
}

static
struct list* build_list(size_t len, struct data store[]) {
  struct list *list = calloc(1, sizeof (struct list));
  for (struct data *cur = store; len; len--) {
    cur->lst_.next = list->next;
    list->next = &cur->lst_;
    cur->val = len;
    cur += 1;
  }
  return list;
}

static
void print_list(struct list *list, const char *prefix) {
  int line, base;
  base = line = printf("%s =", prefix);
  if (list->next == NULL) {
    printf(" EMPTY\n");
    return;
  }
  for (struct list *cur = list; cur->next; cur = cur->next) {
    if (line > 72) {
      printf("\n%*s", base, "");
      line = base;
    }
    struct data *data = containerof(struct data, lst_, cur->next);
    line += printf(" -> %3zu", data->val);
  }
  printf("\n");
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  struct data *store;
  struct list *list;
  store = calloc(len + 2, sizeof (struct data));
  list = build_list(len, store);
  print_list(list, "list");
  printf("list_reverse(list)\n");
  list_reverse(list);
  print_list(list, "list");
  free(list);
  free(store);
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  struct data *store;
  struct list *list;
  store = calloc(len + 2, sizeof (struct data));
  list = build_randlist(len, store);
  print_list(list, "list");
  printf("list_reverse(list)\n");
  list_reverse(list);
  print_list(list, "list");
  free(list);
  free(store);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
